<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/25/2004 *
 * ===================                          Last change: 09/25/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-beg.php                                      *
 * -------------------------------------------------------------------- *
 * Short description : Begging link                                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Bettel-Link                                      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.3.4');

// Version history array (add more with , '0.0.1' and so on)
setExtensionVersionHistory(array('0.0.0', '0.0.1', '0.0.2', '0.0.3', '0.0.4', '0.0.5', '0.0.6', '0.0.7', '0.0.8', '0.0.9', '0.1.0', '0.1.1', '0.1.2', '0.1.3', '0.1.4', '0.1.5', '0.1.6', '0.1.7', '0.1.8', '0.1.9', '0.2.0', '0.2.1', '0.2.2', '0.2.3', '0.2.4', '0.2.5', '0.2.6', '0.2.7', '0.2.8', '0.2.9', '0.3.0', '0.3.1', '0.3.2', '0.3.3', '0.3.4'));

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running
		// SQL commands to run
		// - Menu systems
		addAdminMenuSql('setup', 'config_beg', 'Bettel-Link', 'IP-Sperre, {OPEN_CONFIG}POINTS{CLOSE_CONFIG}-Verg&uuml;tung usw. k&ouml;nnen Sie hier einstellen.', 10);
		addGuestMenuSql('members', 'beg', '{OPEN_CONFIG}POINTS{CLOSE_CONFIG} erbetteln!', 4);
		addMemberMenuSql('extras', 'beg', 'Ihr Bettel-Link', 1);
		// - Configuration
		addConfigAddSql('beg_timeout', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 600');
		addConfigAddSql('beg_userid_timeout', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 1800');
		addConfigAddSql('beg_points', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00100');
		addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` ADD `beg_clicks` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');

		// Table for IP locks
		addDropTableSql('beg_ips');
		addCreateTableSql('beg_ips', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`remote_ip` VARCHAR(15) NOT NULL DEFAULT '0.0.0.0',
`timeout` VARCHAR(10) NOT NULL DEFAULT '',
`sid` VARCHAR(255) NOT NULL DEFAULT '',
PRIMARY KEY (`id`),
INDEX (`userid`)",
			'IP lock data for beg links');
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addDropTableSql('beg_ips');
		addDropTableSql('beg_referrals');
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `what` IN ('config_beg','list_beg','list_beg_referral_urls')");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE `what`='beg'");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what` IN ('beg','beg2')");

		// Unregister points data
		unregisterExtensionPointsData('beg');
		unregisterExtensionPointsData('beg_ref');
		unregisterExtensionPointsData('monthly_beg');
		unregisterExtensionPointsData('monthly_beg_ref');

		// Unregister module
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_mod_reg` WHERE `module`='beg' LIMIT 1");

		// Unregister filter
		unregisterFilter(__FILE__, __LINE__, 'pre_user_registration', 'BEG_RALLYE_USER_REGISTRATION_ADD_SQL_COLUMNS', true, isExtensionDryRun());
		unregisterFilter(__FILE__, __LINE__, 'init', 'BEG_PURGE_IPS_NOTIFY_USER', true, isExtensionDryRun());
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `visible`='Y',`locked`='N' WHERE `what`='beg' LIMIT 1");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='Y',`locked`='N' WHERE `what` IN ('beg','beg2')");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_mod_reg` SET `locked`='N',`hidden`='N',`admin_only`='N',`mem_only`='N' WHERE `module`='beg' LIMIT 1");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_mod_reg` SET `locked`='N',`hidden`='N',`admin_only`='N',`mem_only`='N' WHERE `module`='beg' LIMIT 1");
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `visible`='N',`locked`='Y' WHERE `what`='beg' LIMIT 1");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='N',`locked`='Y' WHERE `what` IN('beg','beg2')");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_mod_reg` SET `locked`='Y' WHERE `module`='beg' LIMIT 1");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_mod_reg` SET `locked`='Y' WHERE `module`='beg' LIMIT 1");
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Design &quot;Solid-Business&quot; eingebaut.");
				break;

			case '0.0.2': // SQL queries for v0.0.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Seit <strong>Patch 340</strong> &uuml;berfl&uuml;ssige HTML-Tags entfernt.");
				break;

			case '0.0.3': // SQL queries for v0.0.3
				addConfigAddSql('beg_points_max', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.10000');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Maximale Obergrenze an {?POINTS?} einstellbar (Standard: 0,1 {?POINTS?})");
				break;

			case '0.0.4': // SQL queries for v0.0.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("&Uuml;berlange Kommastellen bei Punktangaben aus Bettellink und Gastbereich entfernt und Admin-Templates repariert (&quot;Unbekannte Spalte <u>beg_points_ma</u>&quot;).");
				break;

			case '0.0.5': // SQL queries for v0.0.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Im Mitgliedsmen&uuml; wurde die Beschreibung aus dem Gastmen&uuml; verwendet.");
				break;

			case '0.0.6': // SQL queries for v0.0.6
				addConfigAddSql('beg_userid', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Ein Mitgliedsaccount (empfehlenswert ist Ihr eigenes!) kann zum Abbuchen der {?POINTS?} verwendet werden. Template <u>admin_config_beg.tpl</u> (und pro!) nicht vergessen, zu aktualisieren.");
				break;

			case '0.0.8': // SQL queries for v0.0.8
				addConfigAddSql('beg_ip_timeout', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 1800');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Zeitsperre gegen die selbe IP-Nummer hinzugef&uuml;gt.");
				break;

			case '0.0.9': // SQL queries for v0.0.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Bitte verschieben Sie die beg-Templates (Ordner: {?PATH?}/templates/".getLanguage()."/html/) in den neuen Order beg!");
				break;

			case '0.1.0': // SQL queries for v0.2.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Abspeichern von Einstellungen repariert.");
				break;

			case '0.1.1': // SQL queries for v0.1.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Vorbereitung auf die neue Mediendaten v0.0.4.");
				break;

			case '0.1.2':
				// SQL queries for v0.1.2
				addConfigAddSql('beg_ranks', 'TINYINT(3) UNSIGNED NOT NULL DEFAULT 10');
				addConfigAddSql('beg_active', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('beg_rallye', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` ADD `beg_points` FLOAT(21,5) UNSIGNED NOT NULL DEFAULT 0.00000");

				// Menu system
				addAdminMenuSql('user', 'list_beg', 'Bettel-Rallye', 'Listet alle Teilnehmer der monatlichen Bettel-Rallye auf.', 12);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Optionale Bettel-Rallye m&ouml;glich. Und die erbettelten {?POINTS?} k&ouml;nnen entweder nur dem bettelndem Mitglied direkt oder auch seinem Werber gutgeschrieben werden k&ouml;nnen.");
				break;

			case '0.1.3': // SQL queries for v0.1.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Erbettelte {?POINTS?} werden nach Deaktivierung der Bettel-Rallye gel&ouml;scht.");
				break;

			case '0.1.4': // SQL queries for v0.1.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Rechtlichen Hinweis im Mitgliedsbereich vergessen (<strong>member_list_beg.tpl</strong>); Template <strong>member_beg_404.tpl</strong> fehlte!");
				break;

			case '0.1.5': // SQL queries for v0.1.5
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `title`='Bettellink/-rallye', descr='IP-Sperre, {OPEN_CONFIG}POINTS{CLOSE_CONFIG}-Verg&uuml;tung und auch die Bettel-Rallye k&ouml;nnen Sie hier einstellen.' WHERE `what`='config_beg' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehlendes Template im Admin-Bereich hinzugef&uuml;gt. Im Admin-Bereich Hinweis hinzugef&uuml;gt, wenn Bettel-Rallye inaktiv ist. Bitte Script inc/monthly_beg.php l&ouml;schen!");
				break;

			case '0.1.6': // SQL queries for v0.1.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Es wurden immer dem ersten bettelndem Mitglied die {?POINTS?} gutgeschrieben.");
				break;

			case '0.1.7': // SQL queries for v0.1.7
				addConfigAddSql('beg_ral_en_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('beg_ral_di_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('beg_new_mem_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('beg_notify_bonus', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000');
				addConfigAddSql('beg_notify_wait', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 30');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` ADD `beg_ral_notify` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` ADD `beg_ral_en_notify` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` ADD `beg_ral_di_notify` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Die Mitglieder k&ouml;nnen nun optional automatisch &uuml;ber eine aktivierte und/oder deaktivierte Bettel-Rallye informiert werden. Beide Benachrichtigungen k&ouml;nnen Sie unter <strong>Einstellungen --&gt; Bettel-Link/-rallye</strong> seperat ein- und ausschalten! Zudem ist eine Sperre gegen eingeloggte Mitglieder eingebaut, die das Klicken auf den eigenen Bettel-Link etwas erschweren soll.");
				break;

			case '0.1.8': // SQL queries for v0.1.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler im t&auml;glichen Reset beseitigt.");
				break;

			case '0.1.9': // SQL queries for v0.1.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("De-/Aktivieren des mit dieser Erweiterung verkn&uuml;pften Modules eingebunden.");
				break;

			case '0.2.0': // SQL queries for v0.2.0
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Bei {?POINTS?}-Gleichstand wird als n&auml;chstes nach wer als letztes Online war umsortiert.");
				break;

			case '0.2.1': // SQL queries for v0.2.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler <strong>unknown column &#39;userid&#39;</strong> beseitigt.");
				break;

			case '0.2.2': // SQL queries for v0.2.2
				addConfigAddSql('beg_include_own', "ENUM('Y','N') NOT NULL DEFAULT 'N'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Eigene Mitglied-Ids sind von der Bettel-Rallye nun ausschliessbar.");
				break;

			case '0.2.3': // SQL queries for v0.2.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Abfrage des Account-Status eingebaut. Es k&ouml;nnen nur best&auml;tigte Accounts betteln.");
				break;

			case '0.2.4': // SQL queries for v0.2.4
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `action`='extras',`sort`=1 WHERE `what`='beg' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Mitgliedsmen&uuml; komplett umgebaut.");
				break;

			case '0.2.5': // SQL queries for v0.2.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehlerhinweis bei deaktivierter Erweiterung verbessert.");
				break;

 			case '0.2.6': // SQL queries for v0.2.6
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_beg_ips` ADD `sid` VARCHAR(255) NOT NULL DEFAULT ''");
				addConfigAddSql('beg_pay_mode', "ENUM('IMG','JS','BOTH','NONE') DEFAULT 'NONE' NOT NULL ;");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("IP-Lock mit Session-Id erweitert. Tracker-Script eingef&uuml;gt, dass das Einbinden des Bettel-Links als Bild/Script/CSS verhindern soll.");
				break;

			case '0.2.7': // SQL queries for v0.2.7
				addConfigChangeSql('beg_ral_en_notify', 'beg_ral_enable_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigChangeSql('beg_ral_di_notify', 'beg_ral_disable_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigChangeSql('beg_new_mem_notify', 'beg_new_member_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` CHANGE `beg_ral_en_notify` `beg_ral_enable_notify` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` CHANGE `beg_ral_di_notify` `beg_ral_disable_notify` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Umbenannt nach neuer Namenskonvention");
				break;

			case '0.2.8': // SQL queries for v0.2.8
				addConfigChangeSql('beg_ral_enable_notify', 'beg_rallye_enable_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigChangeSql('beg_ral_disable_notify', 'beg_rallye_disable_notify', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` CHANGE `beg_ral_enable_notify` `beg_rallye_enable_notify` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` CHANGE `beg_ral_disable_notify` `beg_rallye_disable_notify` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Umbenannt nach neuer Namenskonvention");
				break;

			case '0.2.9': // SQL queries for v0.2.9
				addDropTableSql('beg_referrals');
				addCreateTableSql('beg_referrals', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`userid` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`remote_ip` VARCHAR(15) NOT NULL DEFAULT '0.0.0.0',
`timestamp` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
`referral_url` TINYTEXT NOT NULL,
PRIMARY KEY (`id`),
INDEX (`userid`)",
					'Recorded referral URLs');

				// Add admin menu
				addAdminMenuSql('user','list_beg_referral_urls','Bettel-Referrals auflisten','Listet alle Bettellink-Aufrufe inklusive Referral-URL auf.','13');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Loggen der Referral-URLs hinzugef&uuml;gt.");
				break;

			case '0.3.0': // SQL queries for v0.3.0
				addConfigDropSql('beg_mode');

				// Register points data
				registerExtensionPointsData('beg'        , 'points', 'LOCKED', 'DIRECT');
				registerExtensionPointsData('monthly_beg', 'points', 'LOCKED', 'DIRECT');

				// This depends on ext-sql_patches
				addExtensionDependency('sql_patches');

				// Update notes
				setExtensionUpdateNotes("Monatliche Bettelrallye und die erbettelten {?POINTS?} werden nun &uuml;ber die Tabelle <strong>{OPEN_CONFIG}_MYSQL_PREFIX{CLOSE_CONFIG}_points_data</strong> verwaltet.");
				break;

			case '0.3.1': // SQL queries for v0.3.1
				// Add/move menu
				addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what`='beg2'");
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `action`='members',`sort`=3 WHERE `what`='beg' LIMIT 1");
				addMemberMenuSql('rals', 'beg2', 'Bettel-Rallye', 3);

				// Update notes
				setExtensionUpdateNotes("Bettel-Rallye re-hinzugef&uuml;gt.");
				break;

			case '0.3.2': // SQL queries for v0.3.2
				// Add module entry
				addModuleSql('beg', '{OPEN_TEMPLATE}MODULE_BEG_TITLE{CLOSE_TEMPLATE}', 'Y', 'Y', 'N', 'N');

				// Set module title
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_mod_reg` SET `title`='Betteln bei {OPEN_CONFIG}MAIN_TITLE{CLOSE_CONFIG}' WHERE `module`='beg' AND `title`='' LIMIT 1");

				// Update notes
				setExtensionUpdateNotes("Modul registriert und bei leerem Titel mit einem Standardtitel versehen.");
				break;

			case '0.3.3': // SQL queries for v0.3.3
				// Register a filter
				registerFilter(__FILE__, __LINE__, 'pre_user_registration', 'BEG_RALLYE_USER_REGISTRATION_ADD_SQL_COLUMNS', false, true, isExtensionDryRun());
				registerFilter(__FILE__, __LINE__, 'init', 'BEG_PURGE_IPS_NOTIFY_USER', false, true, isExtensionDryRun());

				// This depends on ext-register
				addExtensionDependency('register');

				// Update notes
				setExtensionUpdateNotes("Filter f&uuml;r Anmeldeformular und Aufr&auml;men der IPs hinzugef&uuml;gt.");
				break;

			case '0.3.4': // SQL queries for v0.3.4
				// Register points data
				registerExtensionPointsData('beg_ref'        , 'points', 'LOCKED', 'DIRECT');
				registerExtensionPointsData('monthly_beg_ref', 'points', 'LOCKED', 'DIRECT');

				// SQL queries (renaming)
				addRenameTableSql('beg_referrals', 'referrals');
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_beg_referrals` CHANGE `referal_url` `referral_url` TINYTEXT NOT NULL");
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `what`='list_beg_referral_urls' WHERE `what`='list_beg_referal_urls' LIMIT 1");

				// Update notes
				setExtensionUpdateNotes("Verwendungszwecke f&uuml;r Referralgutgschriften registriert.");
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // When extension is initialized
		break;

	default: // Unknown extension mode
		logDebugMessage(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
